import csv
import json
import os
import re

def initialiseCSVFile(name: str):
    header = ['category', 'all methods', 'possibly obfuscated methods','internal methods']
    with open(name, 'w', encoding='UTF8') as f:
        writer = csv.writer(f)
        # write the header
        writer.writerow(header)

def find_all_files(folder,ext):
    ext_files = []
    for root, dirs, files in os.walk(folder):
        for file in files:
            if file.endswith(f'.{ext}'):
                ext_files.append(os.path.join(root, file))
    return ext_files

def statsOnTPLs(lst):
    ctr = 0
    obfuscated_list = []
    print("collecting stats")
    for l in lst:
        x = l.split(":",2)
        xx = x[0].split(".")
        #print(x)
        for xxx in xx:
            if len(xxx) == 1 or xxx.startswith('zz') or xxx == "zbe":
                    ctr = ctr + 1
                    if l not in obfuscated_list:
                        obfuscated_list.append(l)
                    break
            elif len(xxx) == 2 and (xxx == "io" or xxx == "ui" or xxx == "ml" or xxx == "ec"):
                    pass #Not obfuscated
            elif len(xxx) == 2:
                    ctr = ctr + 1
                    if l not in obfuscated_list:
                        obfuscated_list.append(l)
                    break
    print("Possible obfuscation found in",len(obfuscated_list),"methods")
    return obfuscated_list

def diffList(li1, li2):
    s = set(li2)
    temp3 = [x for x in li1 if x not in s]
    return temp3

def print_dict(file,dict):
    with open(file, "w") as fp:
        json.dump(dict, fp, indent = 2)

def init_dict(dict):
    dict = {
    'Category' : 'Methods'
    }

def print_list(file, lst):
    with open(file, "w") as fp:
        for l in lst:
            fp.write("%s\n" % l)

current_dir = os.path.dirname(os.path.abspath(__file__))
output_dir = f'{current_dir}/output/constructPrivacyRelevantDataset'
csv_file = f'{current_dir}/possibledataset/dataset_stats.csv'
initialiseCSVFile(csv_file)

json_files = find_all_files(output_dir, 'json')
account_present = False
bluetooth_present = False
location_present = False
device_present = False
audio_present = False
media_present = False
database_present = False
network_present = False
email_present = False
auth_present = False
wifi_present = False
advertisements_present = False
aa_present = False
analytics_present = False
dataserialization_present = False
imageloader_present = False
imageprocessing_present = False
logging_present = False

auth_value = {""}
account_value = {""}
bluetooth_value = {""}
location_value = {""}
device_value = {""}
audio_value = {""}
media_value = {""}
database_value = {""}
email_value = {""}
wifi_value = {""}
advertisements_value = {""}
aa_value = {""}
analytics_value = {""}
dataserialization_value = {""}
imageloader_value = {""}
imageprocessing_value = {""}
logging_value = {""}

network_value = {""}
if json_files is not None:
    for f in json_files:
      #  print(f)
        with open(f) as ff:
            Data= json.load(ff) 
        #Define a new dictionary and add value of every key to it
        if isinstance(Data, dict):
            for k, v in Data.items():
                if k == 'Account':
                    account_present = True
                    account_value = account_value | set(v)
                if k == 'Bluetooth':
                    bluetooth_present = True
                    bluetooth_value = bluetooth_value | set(v)
                if k == 'Location':
                    location_present = True
                    location_value = location_value | set(v)
                if k == 'Device':
                    device_present = True
                    device_value = device_value | set(v)
                if k == 'Audio':
                    audio_present = True
                    audio_value = audio_value | set(v) 
                if k == 'Media':
                    media_present = True
                    media_value = media_value | set(v)
                if k == 'Database':
                    database_present = True
                    database_value = database_value | set(v)
                if k == 'Network':
                    network_present = True
                    network_value = network_value | set(v)
                if k == 'Email':
                    email_present = True
                    email_value =  email_value | set(v)
                if k == 'Authentication':
                    auth_present = True
                    auth_value = auth_value | set(v)
                if k == 'Wifi':
                    wifi_present = True
                    wifi_value = wifi_value | set(v)
                if k == 'Advertisements':
                    advertisements_present = True
                    advertisements_value = advertisements_value | set(v)
                if k == 'Analytics, Advertisements':
                    aa_present = True
                    aa_value = aa_value | set(v)
                if k == 'Analytics':
                    analytics_present = True
                    analytics_value = analytics_value | set(v)
                if k == 'Data Serialization':
                    dataserialization_present = True
                    dataserialization_value = dataserialization_value | set(v)
                if k == 'Image Loader':
                    imageloader_present = True
                    imageloader_value = imageloader_value | set(v)
                if k == 'Image Processing':
                    imageprocessing_present = True
                    imageprocessing_value = imageprocessing_value | set(v)
                if k == 'Logging':
                    logging_present = True
                    logging_value = logging_value | set(v)

account_dict = {'Category' : 'Methods'}
bluetooth_dict = {'Category' : 'Methods'}
location_dict = {'Category' : 'Methods'}
device_dict = {'Category' : 'Methods'}
audio_dict = {'Category' : 'Methods'}
media_dict = {'Category' : 'Methods'}
database_dict = {'Category' : 'Methods'}
network_dict = {'Category' : 'Methods'}
email_dict = {'Category' : 'Methods'}
auth_dict = {'Category' : 'Methods'}
wifi_dict = {'Category' : 'Methods'}
advertisements_dict = {'Category' : 'Methods'}
aa_dict = {'Category' : 'Methods'}
analytics_dict = {'Category' : 'Methods'}
dataserialization_dict = {'Category' : 'Methods'}
imageloader_dict = {'Category' : 'Methods'}
imageprocessing_dict = {'Category' : 'Methods'}
logging_dict = {'Category' : 'Methods'}
subs = '.internal.'
all_unobfuscated_methods = 0
all_methods = 0
if account_present:
    all_methods = all_methods + len(account_value)
    all_unobfuscated_methods = all_unobfuscated_methods + len(account_value)
    account_dict['Account'] = list(account_value)
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Account",len(account_value), "",  ""]
        writer = csv.writer(f)
        writer.writerow(data)
if bluetooth_present:
    all_methods = all_methods + len(bluetooth_value)
    bluetooth_dict['Bluetooth'] = list(bluetooth_value)
    all_unobfuscated_methods = all_unobfuscated_methods + len(bluetooth_value)
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Bluetooth",len(bluetooth_value), "",  ""]
        writer = csv.writer(f)
        writer.writerow(data)
if location_present:
    all_methods = all_methods + len(location_value)
    all_unobfuscated_methods = all_unobfuscated_methods + len(location_value)
    location_dict['Location'] = list(location_value)
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Location",len(location_value), "",  ""]
        writer = csv.writer(f)
        writer.writerow(data)
if device_present:
    all_methods = all_methods + len(device_value)
    all_unobfuscated_methods = all_unobfuscated_methods + len(device_value)
    device_dict['Device'] = list(device_value)
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Device",len(device_value), "",  ""]
        writer = csv.writer(f)
        writer.writerow(data)
if audio_present:
    all_methods = all_methods + len(audio_value)
    all_unobfuscated_methods = all_unobfuscated_methods + len(audio_value)
    audio_dict['Audio'] = list(audio_value)
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Audio",len(audio_value), "",  ""]
        writer = csv.writer(f)
        writer.writerow(data)
if media_present:
    all_methods = all_methods + len(media_value)
    all_unobfuscated_methods = all_unobfuscated_methods + len(media_value)
    media_dict['Media'] = list(media_value)
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Media",len(media_value), "",  ""]
        writer = csv.writer(f)
        writer.writerow(data)
if database_present:
    all_methods = all_methods + len(database_value)
    all_unobfuscated_methods = all_unobfuscated_methods + len(database_value)
    database_dict['Database'] = list(database_value)
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Database",len(database_value), "",  ""]
        writer = csv.writer(f)
        writer.writerow(data)
if network_present:
    all_methods = all_methods + len(network_value)
    network_obfuscated = statsOnTPLs(list(network_value))
    network_unobfuscated = diffList(network_value,network_obfuscated)
    network_dict['Network'] = list(network_unobfuscated)
    print_list("possibledataset/Network_obfuscated.txt", network_obfuscated)
    all_unobfuscated_methods = all_unobfuscated_methods + len(network_unobfuscated)
    res = [i for i in list(network_value) if subs in i]
    print("Internal methods in network = ", len(res))
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Network",len(network_value), len(network_obfuscated),  ""]
        writer = csv.writer(f)
        writer.writerow(data)
if email_present:
    all_methods = all_methods + len(email_value)
    all_unobfuscated_methods = all_unobfuscated_methods + len(email_value)
    email_dict['Email'] = list(email_value)
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Email",len(email_value), "",  ""]
        writer = csv.writer(f)
        writer.writerow(data)
if auth_present:
    all_methods = all_methods + len(auth_value)
    auth_obfuscated = statsOnTPLs(list(auth_value))
    auth_value_unobfuscated = diffList(auth_value,auth_obfuscated)
    auth_dict['Authentication'] = list(auth_value_unobfuscated)
    print_list("possibledataset/Auth_obfuscated.txt", auth_obfuscated)
    all_unobfuscated_methods = all_unobfuscated_methods + len(auth_value_unobfuscated)
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Authentication",len(auth_value),len(auth_obfuscated),  ""]
        writer = csv.writer(f)
        writer.writerow(data)
if wifi_present:
    all_methods = all_methods + len(wifi_value)
    all_unobfuscated_methods = all_unobfuscated_methods + len(wifi_value)
    wifi_dict['Wifi'] = list(wifi_value)
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Wifi",len(wifi_value), "",  ""]    
        writer = csv.writer(f)
        writer.writerow(data)
if advertisements_present:
    all_methods = all_methods + len(advertisements_value)
    ads_obfuscated = statsOnTPLs(list(advertisements_value))
    ads_value_unobfuscated = diffList(advertisements_value, ads_obfuscated)
    advertisements_dict['Advertisements'] = list(ads_value_unobfuscated)
    #print(ads_value_unobfuscated)
    print_list("possibledataset/Ads_obfuscated.txt",ads_obfuscated)
    all_unobfuscated_methods = all_unobfuscated_methods + len(ads_value_unobfuscated)
    res = [i for i in list(advertisements_value) if subs in i]
    print("Internal methods in advertisements = ", len(res))
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Advertisements",len(advertisements_value), len(ads_obfuscated),  len(res)]    
        writer = csv.writer(f)
        writer.writerow(data)
if aa_present:
    all_methods = all_methods + len(aa_value)
    aa_obfuscated = statsOnTPLs(list(aa_value))
    aa_value_unobfuscated = diffList(aa_value, aa_obfuscated)
    aa_dict['Analytics, Advertisements'] = list(aa_value_unobfuscated)
    print_list("possibledataset/Aa_obfuscated.txt",aa_obfuscated)
    all_unobfuscated_methods = all_unobfuscated_methods + len(aa_value_unobfuscated)
    res = [i for i in list(aa_value) if subs in i]
    print("Internal methods in analytics and advertisements = ", len(res))
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Analytics, Advertisements",len(aa_value), len(aa_obfuscated),  len(res)]
        writer = csv.writer(f)
        writer.writerow(data)
if analytics_present:
    all_methods = all_methods + len(analytics_value)
    analytics_obfuscated = statsOnTPLs(list(analytics_value))
    analytics_value_unobfuscated = diffList(analytics_value, analytics_obfuscated)
    analytics_dict['Analytics'] = list(analytics_value_unobfuscated)
    print_list("possibledataset/Analytics_obfuscated.txt",analytics_obfuscated)
    all_unobfuscated_methods = all_unobfuscated_methods + len(analytics_value_unobfuscated)
    res = [i for i in list(analytics_value) if subs in i]
    print("Internal methods in analytics = ", len(res))
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Analytics",len(analytics_value), len(analytics_obfuscated),  len(res)]
        writer = csv.writer(f)
        writer.writerow(data)
if dataserialization_present:
    all_methods = all_methods + len(dataserialization_value)
    data_value_obfuscated = statsOnTPLs(list(dataserialization_value))
    data_value_unobfuscated = diffList(dataserialization_value, data_value_obfuscated)
    dataserialization_dict['Data Serialization'] = list(data_value_unobfuscated)
    print_list("possibledataset/DataSerialization_obfuscated.txt",data_value_obfuscated)
    all_unobfuscated_methods = all_unobfuscated_methods + len(data_value_unobfuscated)
    res = [i for i in list(dataserialization_value) if subs in i]
    print("Internal methods in data serialization = ", len(res))
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Data Serialization",len(dataserialization_value), len(data_value_unobfuscated),  len(res)]
        writer = csv.writer(f)
        writer.writerow(data)
if imageloader_present:
    all_methods = all_methods + len(imageloader_value)
    imagel_value_obfuscated = statsOnTPLs(list(imageloader_value))
    imagel_value_unobfuscated = diffList(imageloader_value, imagel_value_obfuscated)
    imageloader_dict['Image Loader'] = list(imagel_value_unobfuscated)
    print_list("possibledataset/ImageLoader_obfuscated.txt",imagel_value_obfuscated)
    all_unobfuscated_methods = all_unobfuscated_methods + len(imagel_value_unobfuscated)
    res = [i for i in list(imageloader_value) if subs in i]
    print("Internal methods image loaders = ", len(res))
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Image Loader",len(imageloader_value), len(imagel_value_obfuscated),  len(res)]
        writer = csv.writer(f)
        writer.writerow(data)
if imageprocessing_present:
    all_methods = all_methods + len(imageprocessing_value)
    ip_value_obfuscated = statsOnTPLs(list(imageprocessing_value))
    ip_value_unobfuscated = diffList(imageprocessing_value, ip_value_obfuscated)
    imageprocessing_dict['Image Processing'] = list(ip_value_unobfuscated)
    print_list("possibledataset/ImageProcessing_obfuscated.txt",ip_value_obfuscated)
    all_unobfuscated_methods = all_unobfuscated_methods + len(ip_value_unobfuscated)
    res = [i for i in list(imageprocessing_value) if subs in i]
    print("Internal methods in image processing = ", len(res))
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Image Processing",len(imageprocessing_value), len(ip_value_obfuscated),  len(res)]
        writer = csv.writer(f)
        writer.writerow(data)
if logging_present:
    all_methods = all_methods + len(logging_value)
    log_value_obfuscated = statsOnTPLs(list(logging_value))
    log_value_unobfuscated = diffList(logging_value, log_value_obfuscated)
    logging_dict['Logging'] = list(log_value_unobfuscated)
    print_list("possibledataset/Logging_Obfuscated.txt",log_value_obfuscated)
    all_unobfuscated_methods = all_unobfuscated_methods + len(log_value_unobfuscated)
    res = [i for i in list(logging_value) if subs in i]
    print("Internal methods in logging = ", len(res))
    with open(csv_file, 'a', encoding='UTF8', newline='') as f:
        data = ["Logging",len(logging_value), len(log_value_obfuscated),  len(res)]
        writer = csv.writer(f)
        writer.writerow(data)
#print(privacy_dict)
print("Total no. of methods = ",all_methods)
print("Total no. of unobfuscated methods = ",all_unobfuscated_methods)

print_dict("possibledataset/AccountMethods.json", account_dict)
print_dict("possibledataset/BluetoothMethods.json",bluetooth_dict)
print_dict("possibledataset/LocationMethods.json",location_dict)
print_dict("possibledataset/DeviceMethods.json",device_dict)
print_dict("possibledataset/AudioMethods.json",audio_dict)
print_dict("possibledataset/MediaMethods.json",media_dict)
print_dict("possibledataset/DatabaseMethods.json",database_dict)
print_dict("possibledataset/NetworkMethods.json",network_dict)
print_dict("possibledataset/EmailMethods.json",email_dict)
print_dict("possibledataset/WifiMethods.json",wifi_dict)
#TPLs
print_dict("possibledataset/AuthenticationMethods.json",auth_dict)
print_dict("possibledataset/AdvertisementsMethods.json",advertisements_dict)
print_dict("possibledataset/AdsAnalyticsMethods.json",aa_dict)
print_dict("possibledataset/AnalyticsMethods.json",analytics_dict)
print_dict("possibledataset/DataSerializationMethods.json",dataserialization_dict)
print_dict("possibledataset/ImageLoaderMethods.json",imageloader_dict)
print_dict("possibledataset/ImageProcessingMethods.json",imageprocessing_dict)
print_dict("possibledataset/LoggingMethods.json",logging_dict)

