import os 
import pandas as pd
#Installation needed: pip install xlrd
#The following script prepares the files that will be input to PrivacyFX. 

def prepareIdentifierDataset(input_file, output_file):
    sheets = ['Identifiable', 'Partially Identifiable', 'Access', 'Context Dependent']
    df = pd.concat([pd.read_excel(input_file, sheet_name = sheet) for sheet in sheets], ignore_index = True)             
    df = pd.DataFrame(df, columns=['Method', 'Label', 'Identifier'])
    print(df)
    df.to_csv(output_file,sep='#',index=False,header=False)

def prepareTPLFile(input_file, output_file):
    sheets = ['Identifiable', 'Partially Identifiable', 'Access', 'Context Dependent']
    df = pd.concat([pd.read_excel(input_file, sheet_name = sheet) for sheet in sheets], ignore_index = True)
    #["Identifiable","Partially Identifiable"]) #["Identifiable", "Partially Identifiable", "Access", "Context Dependent"])
    tp_list = {}
    sheet1 = list(df.keys())[0]
    df = pd.DataFrame(df, columns=['Method', 'TPL'])
    print(df)
    df.to_csv(output_file,sep='#',index=False,header=False)
 
def preparePermissionsFile(input_file, output_file):
    sheets = ['Identifiable', 'Partially Identifiable', 'Access', 'Context Dependent']
    df = pd.concat([pd.read_excel(input_file, sheet_name = sheet) for sheet in sheets], ignore_index = True)             
    df = pd.DataFrame(df, columns=['Method', 'Permissions'])
    df.to_csv(output_file,sep='#',index=False,header=False)

def prepareConfigFile(config_file, output_file):
    f = open(config_file, "w")
    f.write("wholeProgFeatureInclusion:\n")
    f.write("- WholeProgramPrivateSourcesAPICallCount\n")
    f.write("featureResources:\n")
    f.write("- {featureName: \"WholeProgramPrivateSourcesAPICallCount\", resourcePath: \"input/")
    f.write(output_file)
    f.write("\"}\n")
    f.close()

current_dir = os.path.dirname(os.path.abspath(__file__))
dataset = f'AnnotatedMethods.xlsx'
txt_file = f'IdentifierAPIDataset.txt'
tpl_file = f'LibraryMethods.txt'
perm_file = f'Permissions.txt'
config = f'config.yaml'
prepareIdentifierDataset(dataset,txt_file)
prepareConfigFile(config, txt_file)
prepareTPLFile(dataset, tpl_file)
preparePermissionsFile(dataset, perm_file)
